=== debian/changelog ===
liblas (1.8.0-7build1) xenial; urgency=medium

  * No change rebuild against libgdal.so.1-1.11.3.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 20 Nov 2015 13:54:40 +0000

liblas (1.8.0-7) unstable; urgency=medium

  * Update symbols for all architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 22 Oct 2015 19:47:01 +0200

liblas (1.8.0-6) unstable; urgency=medium

  * Update Vcs-Browser URL to use HTTPS.
  * Update Source URL in copyright to match watch file.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 22 Oct 2015 09:52:42 +0200

liblas (1.8.0-5) unstable; urgency=medium

  * Update symbols for mips*, hppa & x32.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Aug 2015 19:39:26 +0200

liblas (1.8.0-4) unstable; urgency=medium

  * Update symbols for other architectures except mips*,
    the experimental buildds for mips* aren't active at the moment.
    (closes: #777955)
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Aug 2015 12:09:15 +0200

liblas (1.8.0-4~exp1) experimental; urgency=medium

  * Update symbols for amd64 with GCC 5.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 21 Aug 2015 19:30:05 +0200

liblas (1.8.0-3) unstable; urgency=medium

  * Fix upstream version extraction from changelog.
  * Use multi-line uscan options.
  * Add boost dependencies to liblas-dev.
  * Also install cmake files in liblas-dev.
  * Explicitly remove files not be installed.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 04 Jul 2015 22:42:30 +0200

liblas (1.8.0-2) unstable; urgency=medium

  * Update symbols for: arm64, armel, armhf, hurd-i386, i386, kfreebsd-i386,
    mips, mipsel, powerpc, ppc64el & s390x.
  * Set the date embedded in man pages to the build date for
    reproducible builds.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 27 Apr 2015 11:40:47 +0200

liblas (1.8.0-2~exp1) experimental; urgency=medium

  * Add upstream metadata.
  * Update man page for liblas-config.
  * Update Vcs-Browser URL to use cgit instead of gitweb.
  * Update my email to use @debian.org address.
  * Bump Standards-Version to 3.9.6, no changes.
  * Update copyright file, changes:
    - Simplify Files sections, group by license
    - Correct GPL-3 or later license shortname to GPL-3+
  * Use dh --with python2 instead of calling it in dh_install override.
  * Use pkgkde-gensymbols & pkgkde-symbolshelper to handle symbols.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 06 Feb 2015 17:37:20 +0100

liblas (1.8.0-1) unstable; urgency=medium

  * Move to unstable

 -- Ross Gammon <rossgammon@mail.dk>  Thu, 21 Aug 2014 19:08:29 +0200

liblas (1.8.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop patches applied upstream:
    - boost
    - soversion
    - separator-typo
  * Drop patches backported from upstream:
    - 0001-remove-old-LAStools-utilities-that-don-t-belong-in-liblas.patch
    - update_gdal_geotiff.patch
  * Update fix_library_search patch for SONAME bump.
  * Update package names for SONAME bump.
  * Add build dependencies for boost_iostreams & boost_filesystem.
  * Fix executable-not-elf-or-script for python examples.
  * Add patch to fix 'accommodate' typo.
  * Strip RPATH from binaries.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Sun, 03 Aug 2014 14:17:52 +0200

liblas (1.7.0+dfsg-6) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Add build dependency on liblaszip-dev for compression support.
  * Use dh_install --list-install.
  * Also include lasblock & ts2las programs in liblas-bin.
  * Add patch from upstream to remove old LAStools utilities.
    (closes: #749403)

  [ Ross Gammon ]
  * Ignore quilt dir
  * Update to build against latest gdal (1.11.0)
  * Revert inclusion of liblaszip until it passes the new queue
  * Add myself to uploaders

 -- Ross Gammon <rossgammon@mail.dk>  Fri, 01 Aug 2014 15:26:51 +0200

liblas (1.7.0+dfsg-5) unstable; urgency=low

  * Add myself to Uploaders.
  * Also remove generated man pages on clean.
  * Add gbp.conf to use prinstine-tar by default.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Thu, 06 Mar 2014 23:50:33 +0100
