=== debian/control ===
Source: liblas
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           David Paleino <dapal@debian.org>,
           Bas Couwenberg <sebastic@debian.org>,
           Ross Gammon <rossgammon@mail.dk>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               pkg-kde-tools,
               cmake,
               chrpath,
               libgeotiff-dev,
               libgdal-dev (>= 1.10.0~),
               libtiff-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-thread-dev,
               python-all-dev,
               python-setuptools,
               dh-python,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/liblas.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/liblas.git
Homepage: http://liblas.org/
X-Python-Version: >= 2.5

Package: liblas3
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: libgeotiff-epsg
Description: ASPRS LiDAR data translation library - C++ version
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the C++ shared library used by applications.

Package: liblas-c3
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         liblas3 (= ${binary:Version})
Suggests: libgeotiff-epsg
Description: ASPRS LiDAR data translation library - C version
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the C shared library used by applications.

Package: liblas-dev
Architecture: any
Section: libdevel
Depends: liblas3 (= ${binary:Version}),
         libgeotiff-dev,
         libgdal-dev (>= 1.10.0~),
         libtiff-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-thread-dev,
         ${misc:Depends}
Description: ASPRS LiDAR data translation library - C++ development files
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the development files to build applications in C++.

Package: liblas-c-dev
Architecture: any
Section: libdevel
Depends: liblas-c3 (= ${binary:Version}),
         liblas-dev (= ${binary:Version}),
         libgeotiff-dev,
         libgdal-dev (>= 1.10.0~),
         ${misc:Depends}
Description: ASPRS LiDAR data translation library - C development files
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the development files to build applications in C.

Package: liblas-bin
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: libgeotiff-epsg
Description: ASPRS LiDAR data translation toolset
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains the essential toolset to manage LiDAR data:
 lasinfo, lasmerge, las2las, las2txt, txt2las, las2ogr.

Package: python-liblas
Architecture: all
Section: python
Depends: liblas-c3,
         ${python:Depends},
         ${misc:Depends}
Description: Python module to use the ASPRS LiDAR data translation library
 libLAS is a C/C++ library for reading and writing ASPRS LAS versions
 1.0, 1.1 and 1.2 data. The LAS format is a sequential binary format
 used to store data from sensors and as intermediate processing storage
 by some LiDAR-related applications. LiDAR (Light Detection and Ranging)
 is an optical remote sensing technology that measures properties of
 scattered light to find range and/or other information of a distant
 target. The prevalent method to determine distance to an object or
 surface is to use laser pulses.
 .
 This package contains a Python module to use libLAS.
